<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 3.1  (Unix)">
	<META NAME="CREATED" CONTENT="0;0">
	<META NAME="CHANGED" CONTENT="0;0">
	<STYLE TYPE="text/css">
	<!--
		@page { margin: 2cm }
		P { margin-bottom: 0.21cm; direction: ltr; color: #000000; text-align: left; widows: 0; orphans: 0 }
		P.western { font-family: "Times New Roman", serif; font-size: 12pt; so-language: fr-FR }
		P.cjk { font-family: "Arial Unicode MS", sans-serif; font-size: 12pt; so-language: zxx }
		P.ctl { font-family: "Tahoma"; font-size: 12pt; so-language: zxx }
		H2 { margin-bottom: 0.21cm; direction: ltr; color: #000000; text-align: left; widows: 0; orphans: 0 }
		H2.western { font-family: "Arial", sans-serif; font-size: 14pt; so-language: fr-FR; font-style: italic }
		H2.cjk { font-family: "Arial Unicode MS", sans-serif; font-size: 14pt; so-language: zxx; font-style: italic }
		H2.ctl { font-family: "Tahoma"; font-size: 14pt; so-language: zxx; font-style: italic }
		PRE { direction: ltr; color: #000000; text-align: left; widows: 0; orphans: 0 }
		PRE.western { font-family: "Times New Roman", serif; so-language: fr-FR }
		PRE.cjk { so-language: zxx }
		PRE.ctl { so-language: zxx }
		H3 { margin-bottom: 0.21cm; direction: ltr; color: #000000; text-align: left; widows: 0; orphans: 0 }
		H3.western { font-family: "Arial", sans-serif; so-language: fr-FR }
		H3.cjk { font-family: "Arial Unicode MS", sans-serif; so-language: zxx }
		H3.ctl { font-family: "Tahoma"; so-language: zxx }
	-->
	</STYLE>
</HEAD>
<BODY LANG="fr-FR" TEXT="#000000" DIR="LTR">
<P STYLE="margin-top: 0.42cm; page-break-after: avoid"><FONT FACE="Arial, sans-serif"><FONT SIZE=4>B2B
avec cXML <BR>Principes de mise en oeuvre de la partie cliente</FONT></FONT></P>
<PRE CLASS="western">
<I>Version du 09/10/2009</I>
<I>rodolphe.prin@cocktail.org</I>


<I>Ce document détaille le principe de fonctionnement du B2B en cXML ainsi que la mise en oeuvre avec le framework FwkCktlB2b.</I>


<I>Dans le cadre de l'association Cocktail, le B2B se limite pour l'instant à une expérimentation avec le fournisseur DELL et le but est de mettre en place un système B2B entre le logiciel de gestion des commandes et le site Premier de DELL.</I>

</PRE><H2 CLASS="western">
Définitions</H2>
<PRE CLASS="western"></PRE>
<UL>
	<LI><PRE CLASS="western">B2B : Business To Business. <BR>Définition Wikipédia : «&nbsp;l'ensemble d'architectures techniques et logicielles informatiques permettant de mettre en relation des entreprises&nbsp;».</PRE>
	<LI><PRE CLASS="western">CXML <BR>Protocole basé sur le XML destiné à l'échange de documents commerciaux entre les applications de gestion des commandes, les concentrateurs e-commerce et les fournisseurs.<BR>http://www.cxml.org</PRE>
</UL>
<PRE CLASS="western"></PRE><H2 CLASS="western">
Principes</H2>
<PRE CLASS="western">
L'application de gestion des commandes initie une connexion vers le fournisseur en demandant une URL d'accès au catalogue de ce dernier.
</PRE>
<OL>
	<LI><PRE CLASS="western">L'utilisateur est redirigé vers ce catalogue</PRE>
	<LI><PRE CLASS="western">L'utilisateur construit son panier</PRE>
	<LI><PRE CLASS="western">Lorsque l'utilisateur valide son panier, il est redirigé vers l'application de gestion des commandes qui reçoit en même temps le contenu du panier (avec les référence, prix des articles, etc.) qu'il souhaite commander.</PRE>
	<LI><PRE CLASS="western">Le contenu du panier peut ainsi être intégré dans l'application de gestion des commandes comme une pré-commande.</PRE>
	<LI><PRE CLASS="western">Celle-ci peut donc suivre les différentes étapes de validation.</PRE>
	<LI><PRE CLASS="western">Une fois validée, elle est transmise au fournisseur qui indique s'il l'a prise ou non en compte.</PRE>
</OL>
<PRE CLASS="western">


Il est également possible de retourner modifier le panier sur le site du fournisseur.


<B>Attention</B>
Le panier construit par l'utilisateur <B>n'est pas un devis</B> (les éléments récupérés sont des articles avec leur références et leur prix). 
Lorsqu'on passe la commande finale, on renvoie en fait l'ensemble des articles commandés avec leurs références et leur prix avec un identifiant de commande. Une fois la commande passée, une autre commande ayant le même identifiant ne peut être passée.
</PRE><H2 CLASS="western">
Paramétrage</H2>
<PRE CLASS="western">Le fournisseur doit donner plusieurs informations pour que l'application de gestion des commandes puisse échanger des messages cXML. 
SupplierURL : (URL du fournisseur qui va recevoir les messages envoyés)
Identity : Identifiant
SharedSecret : Mot de passe

Ces paramètres sont propres à chaque établissement, il peut y avoir plusieurs paramètres par fournisseur (par exemple paramètres de tests et paramètres de production).


<I>La table FOURNIS_B2B_CXML_PARAM est créée dans GRHUM pour mémoriser les différents paramètres de connexion pour chaque fournisseur. Pour l'instant il n'y a pas d'interface de saisie.</I>


</PRE><H2 CLASS="western">
Détail des messages échangés</H2>
<PRE CLASS="western">
<B>PunchOutSetupRequest</B> : envoyé par l'application cliente pour demander au fournisseur l'adresse du site qui va permettre à l'utilisateur de construire son panier. Ce message contient notamment une URL (BrowserFormPost) qui sera utilisée ultérieurement par l'application du fournisseur pour renvoyer le message PunchOutOrderMessage.

<B>PunchOutSetupResponse</B> : renvoyé comme réponse au message PunchOutSetupRequest, il contient entre autre un tag startPage qui contient l'URL d'accès au catalogue du fournisseur.

<B>PunchOutOrderMessage</B> : envoyé par le fournisseur à l'URL spécifiée dans le PunchOutSetupRequest lorsque l'utilisateur valide son panier. Il contient notamment l'ensemble du panier.

<B>OrderRequest</B> : Envoyé par l'application cliente au fournisseur pour passer la commande finale. Une réponse est renvoyée par le fournisseur.

<IMG SRC="B2b_avec_cXML_-_Mise_en_oeuvre_html_m267809b.jpg" NAME="images1" ALIGN=LEFT WIDTH=629 HEIGHT=437 BORDER=0><BR CLEAR=LEFT>

</PRE><H2 CLASS="western">
<IMG SRC="B2b_avec_cXML_-_Mise_en_oeuvre_html_47c96a3e.jpg" NAME="images2" ALIGN=LEFT WIDTH=629 HEIGHT=205 BORDER=0><BR CLEAR=LEFT></H2>
<H2 CLASS="western">Le framework FwkCktlB2b – Mise en oeuvre de la
partie cliente</H2>
<PRE CLASS="western">Le framework offre des API pour créer, envoyer et recevoir les messages ci-dessus. Il se base sur le framework référentiel (fwkCktlPersonne) pour faire la conversion entre les entités de GRHUM et les entités cXML.

L'application qui utilise cette fonctionnalité doit être exécutées en https, sinon les données comme les identifiant et les mots de passe du client vont transiter en clair. </PRE><H3 CLASS="western">
<SPAN STYLE="font-weight: normal"><SPAN STYLE="font-style: normal">Pour
rediriger l'utilisateur vers le catalogue du fournisseur </SPAN></SPAN>
</H3>
<PRE CLASS="western"></PRE>
<UL>
	<LI><PRE CLASS="western" STYLE="font-style: normal; font-weight: normal">Récupérer les paramètres cXML du fournisseur</PRE>
	<LI><PRE CLASS="western"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: normal">Utiliser l'API </SPAN></SPAN><I><SPAN STYLE="font-weight: normal">CXMLTransaction.creerTransactionPunchOutSetupRequest</SPAN></I><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: normal">, celle-ci renvoie l'url de connexion</SPAN></SPAN></PRE>
	<LI><PRE CLASS="western" STYLE="font-style: normal; font-weight: normal">Rediriger l'utilisateur vers cette url</PRE>
</UL>
<PRE CLASS="western" STYLE="font-style: normal; font-weight: normal"></PRE><H3 CLASS="western" STYLE="font-weight: normal">
Pour récupérer le contenu du panier constitué par l'utilisateur</H3>
<UL>
	<LI><PRE CLASS="western"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: normal">Ajouter une directAction réagissant à un message PunchOutOrderMessage, c'est à dire qui récupère le panier et renvoie vers une page de l'application qui affiche le panier après l'avoir intégré dans le SI. Voir l'exemple dans l'application </SPAN></SPAN><I><SPAN STYLE="font-weight: normal">CktlB2bTest</SPAN></I><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: normal">, classe </SPAN></SPAN><I><SPAN STYLE="font-weight: normal">org.cocktail.cktlb2btest.server.B2bCxmlDirectAction.</SPAN></I></PRE>
</UL>
<PRE CLASS="western"></PRE><H3 CLASS="western" STYLE="font-weight: normal">
Pour passer la commande finale</H3>
<UL>
	<LI><PRE CLASS="western" STYLE="font-style: normal; font-weight: normal">Récupérer les paramètres cXML du fournisseur</PRE>
	<LI><PRE CLASS="western"><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: normal">Utiliser l'API  </SPAN></SPAN><I><SPAN STYLE="font-weight: normal">CXMLTransaction.creerTransactionOrderRequest . </SPAN></I><SPAN STYLE="font-style: normal"><SPAN STYLE="font-weight: normal">Une exception est déclenchée s'il y a un problème, sinon l'ID de la commande est renvoyé. </SPAN></SPAN></PRE>
</UL>
<PRE CLASS="western">










</PRE>
</BODY>
</HTML>